/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Inline.xs. Do not edit this file, edit Inline.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Inline.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "INLINE.h"

#include <X11/Xlib.h>
#include <X11/X.h>
#include <X11/keysym.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <shadow.h>
#include <crypt.h>

SV *open_connection(){
    Display *display;
    SV *d_sv;
    SV *d_sv_ref;
    display = XOpenDisplay(NULL);
    if (display == NULL){
        croak("Could not open X display connection.");
    }
    d_sv = newSViv((IV)display);
    d_sv_ref = newRV_noinc(d_sv);
    return d_sv_ref;
}

void close_connection(SV* display){
    XCloseDisplay((Display *)SvIV(SvRV(display)));
}

void destroy_window(SV *display, int window){
    XDestroyWindow((Display *)SvIV(SvRV(display)), window);
}

int screen_count(SV *display){
    return XScreenCount((Display *)SvIV(SvRV(display)));
}

int close_window(SV *display, int window){
    XDestroyWindow((Display *)SvIV(SvRV(display)), window);
}

int open_lock(SV *disp_ref, int screen){
    Display *display;
    int window;
    int root;
    int status;
    XColor black, d;
    XSetWindowAttributes attr;
    XEvent event;

    display = (Display *)SvIV(SvRV(disp_ref));
    screen = XDefaultScreen(display);
    root = XRootWindow(display,screen);
    window = XCreateSimpleWindow(display, root, 0, 0, DisplayWidth(display,screen), DisplayHeight(display,screen), 1, BlackPixel(display, screen), BlackPixel(display, screen));
    attr.override_redirect = 1;
    XChangeWindowAttributes(display, window, CWOverrideRedirect, &attr);

    status = XMapRaised(display, window);
    XRaiseWindow(display, window);

    XSync(display,0);

    XSelectInput(display, root, SubstructureNotifyMask);
    return window;
} 

int grab_keyboard(SV *disp_ref, int screen){
    Display *display;
    int root;
    int kgrab;
    int mgrab; 

    display = (Display *)SvIV(SvRV(disp_ref));
    root = XRootWindow(display, screen);
    kgrab = XGrabKeyboard(display, root, True, GrabModeAsync, GrabModeAsync, CurrentTime);
    mgrab = XGrabPointer(display, root, False, ButtonPress | PointerMotionMask, GrabModeAsync, GrabModeAsync, None, None, CurrentTime);
    return (kgrab > 0 && mgrab > 0);
}

void ungrab_keyboard(SV* disp_ref){
    Display *display;
    display = (Display *)SvIV(SvRV(disp_ref));
    XUngrabKeyboard(display, CurrentTime);
    XUngrabPointer(display, CurrentTime);
}

int read_event(SV *d){
    Display *display;
    char buffer[64];
    XEvent event;
    display = (Display *)SvIV(SvRV(d));
    KeySym sym;
    XNextEvent(display, &event);
    int num;

    if (event.type == KeyPress){
         num = XLookupString(&event.xkey, buffer, sizeof buffer, &sym, 0);
     if (num == 1) {
        if (sym == XK_Return){
            return 10;
        }else {
            return buffer[0];
        }
     }

    }
    return -1;
}


int check_unix_password(char *checkpw){
    struct spwd *entry;
    char *pw;
    entry = getspnam(getenv("USER"));
    pw = entry->sp_pwdp;
    return strcmp(pw, crypt(checkpw, pw));
}

#if 0
  "Skipped embedded POD."
#endif
#line 156 "Inline.xs"

#line 135 "Inline.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 279 "Inline.c"

XS_EUPXS(XS_App__PerlXLock_open_connection); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_open_connection)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;

	RETVAL = open_connection();
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_close_connection); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_close_connection)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "display");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	display = ST(0)
;
#line 169 "Inline.xs"
        I32* temp;
#line 311 "Inline.c"
#line 171 "Inline.xs"
        temp = PL_markstack_ptr++;
        close_connection(display);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 322 "Inline.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_App__PerlXLock_destroy_window); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_destroy_window)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "display, window");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	display = ST(0)
;
	int	window = (int)SvIV(ST(1))
;
#line 186 "Inline.xs"
        I32* temp;
#line 344 "Inline.c"
#line 188 "Inline.xs"
        temp = PL_markstack_ptr++;
        destroy_window(display, window);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 355 "Inline.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_App__PerlXLock_screen_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_screen_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "display");
    {
	SV *	display = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = screen_count(display);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_close_window); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_close_window)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "display, window");
    {
	SV *	display = ST(0)
;
	int	window = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = close_window(display, window);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_open_lock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_open_lock)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "disp_ref, screen");
    {
	SV *	disp_ref = ST(0)
;
	int	screen = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = open_lock(disp_ref, screen);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_grab_keyboard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_grab_keyboard)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "disp_ref, screen");
    {
	SV *	disp_ref = ST(0)
;
	int	screen = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = grab_keyboard(disp_ref, screen);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_ungrab_keyboard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_ungrab_keyboard)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "disp_ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	disp_ref = ST(0)
;
#line 221 "Inline.xs"
        I32* temp;
#line 457 "Inline.c"
#line 223 "Inline.xs"
        temp = PL_markstack_ptr++;
        ungrab_keyboard(disp_ref);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 468 "Inline.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_App__PerlXLock_read_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_read_event)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "d");
    {
	SV *	d = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = read_event(d);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_App__PerlXLock_check_unix_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_App__PerlXLock_check_unix_password)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "checkpw");
    {
	char *	checkpw = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = check_unix_password(checkpw);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_App__PerlXLock__Inline); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_App__PerlXLock__Inline)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("App::PerlXLock::open_connection", XS_App__PerlXLock_open_connection);
        newXS_deffile("App::PerlXLock::close_connection", XS_App__PerlXLock_close_connection);
        newXS_deffile("App::PerlXLock::destroy_window", XS_App__PerlXLock_destroy_window);
        newXS_deffile("App::PerlXLock::screen_count", XS_App__PerlXLock_screen_count);
        newXS_deffile("App::PerlXLock::close_window", XS_App__PerlXLock_close_window);
        newXS_deffile("App::PerlXLock::open_lock", XS_App__PerlXLock_open_lock);
        newXS_deffile("App::PerlXLock::grab_keyboard", XS_App__PerlXLock_grab_keyboard);
        newXS_deffile("App::PerlXLock::ungrab_keyboard", XS_App__PerlXLock_ungrab_keyboard);
        newXS_deffile("App::PerlXLock::read_event", XS_App__PerlXLock_read_event);
        newXS_deffile("App::PerlXLock::check_unix_password", XS_App__PerlXLock_check_unix_password);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

